Index: trunk/src/VBox/Devices/Graphics/DevVGA.cpp
===================================================================
--- trunk/src/VBox/Devices/Graphics/DevVGA.cpp	(revision 11284)
+++ trunk/src/VBox/Devices/Graphics/DevVGA.cpp	(revision 11285)
@@ -1231,5 +1231,5 @@
             if (addr >= s->vram_size)
             {
-                AssertMsgFailed(("addr=%VGp - this needs to be done in HC! bank_offset=%08x memory_map_mode=%d\n",
+                AssertMsgFailed(("addr=%RGp - this needs to be done in HC! bank_offset=%08x memory_map_mode=%d\n",
                                  addr, s->bank_offset, memory_map_mode));
                 return VINF_SUCCESS;
@@ -1272,5 +1272,5 @@
             if (addr >= s->vram_size)
             {
-                AssertMsgFailed(("addr=%VGp - this needs to be done in HC! bank_offset=%08x memory_map_mode=%d\n",
+                AssertMsgFailed(("addr=%RGp - this needs to be done in HC! bank_offset=%08x memory_map_mode=%d\n",
                                  addr, s->bank_offset, memory_map_mode));
                 return VINF_SUCCESS;
@@ -1296,5 +1296,5 @@
         if (addr * 4 >= s->vram_size)
         {
-            AssertMsgFailed(("addr=%VGp - this needs to be done in HC! bank_offset=%08x memory_map_mode=%d\n",
+            AssertMsgFailed(("addr=%RGp - this needs to be done in HC! bank_offset=%08x memory_map_mode=%d\n",
                              addr * 4, s->bank_offset, memory_map_mode));
             return VINF_SUCCESS;
@@ -3255,5 +3255,5 @@
         if (GCPhysAddr + cItems * cbItem >= pThis->vram_size)
         {
-            AssertMsgFailed(("GCPhysAddr=%VGp cItems=%#x cbItem=%d\n", GCPhysAddr, cItems, cbItem));
+            AssertMsgFailed(("GCPhysAddr=%RGp cItems=%#x cbItem=%d\n", GCPhysAddr, cItems, cbItem));
             return VINF_SUCCESS;
         }
@@ -3278,5 +3278,5 @@
         if (GCPhysAddr * 2 + cItems * cbItem >= pThis->vram_size)
         {
-            AssertMsgFailed(("GCPhysAddr=%VGp cItems=%#x cbItem=%d\n", GCPhysAddr, cItems, cbItem));
+            AssertMsgFailed(("GCPhysAddr=%RGp cItems=%#x cbItem=%d\n", GCPhysAddr, cItems, cbItem));
             return VINF_SUCCESS;
         }
@@ -3300,5 +3300,5 @@
         if (GCPhysAddr + cItems * cbItem >= pThis->vram_size)
         {
-            AssertMsgFailed(("GCPhysAddr=%VGp cItems=%#x cbItem=%d\n", GCPhysAddr, cItems, cbItem));
+            AssertMsgFailed(("GCPhysAddr=%RGp cItems=%#x cbItem=%d\n", GCPhysAddr, cItems, cbItem));
             return VINF_SUCCESS;
         }
@@ -4776,5 +4776,5 @@
     PPDMDEVINS  pDevIns = pPciDev->pDevIns;
     PVGASTATE   pThis = PDMINS_2_DATA(pDevIns, PVGASTATE);
-    LogFlow(("vgaR3IORegionMap: iRegion=%d GCPhysAddress=%VGp cb=%#x enmType=%d\n", iRegion, GCPhysAddress, cb, enmType));
+    LogFlow(("vgaR3IORegionMap: iRegion=%d GCPhysAddress=%RGp cb=%#x enmType=%d\n", iRegion, GCPhysAddress, cb, enmType));
     AssertReturn(iRegion == 0 && enmType == PCI_ADDRESS_SPACE_MEM_PREFETCH, VERR_INTERNAL_ERROR);
 
Index: trunk/src/VBox/Devices/VMMDev/VBoxDev.cpp
===================================================================
--- trunk/src/VBox/Devices/VMMDev/VBoxDev.cpp	(revision 11284)
+++ trunk/src/VBox/Devices/VMMDev/VBoxDev.cpp	(revision 11285)
@@ -1601,5 +1601,5 @@
 static DECLCALLBACK(int) vmmdevIORAMRegionMap(PPCIDEVICE pPciDev, /*unsigned*/ int iRegion, RTGCPHYS GCPhysAddress, uint32_t cb, PCIADDRESSSPACE enmType)
 {
-    LogFlow(("vmmdevR3IORAMRegionMap: iRegion=%d GCPhysAddress=%VGp cb=%#x enmType=%d\n", iRegion, GCPhysAddress, cb, enmType));
+    LogFlow(("vmmdevR3IORAMRegionMap: iRegion=%d GCPhysAddress=%RGp cb=%#x enmType=%d\n", iRegion, GCPhysAddress, cb, enmType));
     VMMDevState *pThis = PCIDEV_2_VMMDEVSTATE(pPciDev);
     int rc;
Index: trunk/src/VBox/Devices/VMMDev/VMMDevHGCM.cpp
===================================================================
--- trunk/src/VBox/Devices/VMMDev/VMMDevHGCM.cpp	(revision 11284)
+++ trunk/src/VBox/Devices/VMMDev/VMMDevHGCM.cpp	(revision 11285)
@@ -250,5 +250,5 @@
         rc = PDMDevHlpPhysGCPtr2GCPhys(pDevIns, GCPtr, &GCPhys);
 
-        Log(("vmmdevHGCMSaveLinPtr: Page %d: %VGv -> %VGp. %Rrc\n", iPage, GCPtr, GCPhys, rc));
+        Log(("vmmdevHGCMSaveLinPtr: Page %d: %VGv -> %RGp. %Rrc\n", iPage, GCPtr, GCPhys, rc));
 
         if (RT_FAILURE (rc))
@@ -296,5 +296,5 @@
                              PAGE_SIZE;
 
-        Log(("vmmdevHGCMWriteLinPtr: page %d: dst %VGp, src %p, cbWrite %d\n", iPage, GCPhysDst, pu8Src, cbWrite));
+        Log(("vmmdevHGCMWriteLinPtr: page %d: dst %RGp, src %p, cbWrite %d\n", iPage, GCPhysDst, pu8Src, cbWrite));
 
         iPage++;
@@ -597,5 +597,5 @@
                          /* rc = PDMDevHlpPhys2HCVirt (pVMMDevState->pDevIns, physAddr, size, &pHostParm->u.pointer.addr); */
 
-                         Log(("vmmdevHGCMCall: PhysAddr guest parameter %VGp\n", physAddr));
+                         Log(("vmmdevHGCMCall: PhysAddr guest parameter %RGp\n", physAddr));
                          break;
                      }
@@ -699,5 +699,5 @@
                          /* rc = PDMDevHlpPhys2HCVirt (pVMMDevState->pDevIns, physAddr, size, &pHostParm->u.pointer.addr); */
 
-                         Log(("vmmdevHGCMCall: PhysAddr guest parameter %VGp\n", physAddr));
+                         Log(("vmmdevHGCMCall: PhysAddr guest parameter %RGp\n", physAddr));
                          break;
                      }
@@ -1179,5 +1179,5 @@
             PVBOXHGCMCMD pNext = pIter->pNext;
 
-            LogFlowFunc (("Saving %VGp\n", pIter->GCPhys));
+            LogFlowFunc (("Saving %RGp\n", pIter->GCPhys));
             rc = SSMR3PutGCPhys(pSSM, pIter->GCPhys);
             AssertRCReturn(rc, rc);
@@ -1220,5 +1220,5 @@
         AssertRCReturn(rc, rc);
 
-        LogFlowFunc (("Restoring %VGp size %x bytes\n", GCPhys, cbSize));
+        LogFlowFunc (("Restoring %RGp size %x bytes\n", GCPhys, cbSize));
 
         PVBOXHGCMCMD pCmd = (PVBOXHGCMCMD)RTMemAllocZ (sizeof (struct VBOXHGCMCMD));