Index: trunk/src/VBox/Frontends/VBoxBFE/DisplayImpl.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxBFE/DisplayImpl.cpp	(revision 11158)
+++ trunk/src/VBox/Frontends/VBoxBFE/DisplayImpl.cpp	(revision 11307)
@@ -148,5 +148,5 @@
         LogFlow(("VMDisplay::handleDisplayResize: external framebuffer wants us to wait!\n"));
 
-        /* Note: The previously obtained framebuffer lock must be preserved. 
+        /* Note: The previously obtained framebuffer lock must be preserved.
          *       The EMT keeps the framebuffer lock until the resize process completes.
          */
@@ -178,5 +178,5 @@
         /* Framebuffer has completed the resize. Update the connector data. */
         updateDisplayData();
-    
+
         mpDrv->pUpPort->pfnSetRenderVRAM (mpDrv->pUpPort, true);
 
@@ -489,5 +489,5 @@
 
     uint32_t u32ResizeStatus = pDisplay->mu32ResizeStatus;
-    
+
     if (u32ResizeStatus == ResizeStatus_UpdateDisplayData)
     {
@@ -1188,5 +1188,5 @@
 {
     PPDMDRVINS pDrvIns = PDMIBASE_2_PDMDRV(pInterface);
-    PDRVMAINDISPLAY pDrv = PDMINS2DATA(pDrvIns, PDRVMAINDISPLAY);
+    PDRVMAINDISPLAY pDrv = PDMINS_2_DATA(pDrvIns, PDRVMAINDISPLAY);
     switch (enmInterface)
     {
@@ -1213,5 +1213,5 @@
 DECLCALLBACK(int) VMDisplay::drvConstruct(PPDMDRVINS pDrvIns, PCFGMNODE pCfgHandle)
 {
-    PDRVMAINDISPLAY pData = PDMINS2DATA(pDrvIns, PDRVMAINDISPLAY);
+    PDRVMAINDISPLAY pData = PDMINS_2_DATA(pDrvIns, PDRVMAINDISPLAY);
     LogFlow(("VMDisplay::drvConstruct: iInstance=%d\n", pDrvIns->iInstance));
 
Index: trunk/src/VBox/Frontends/VBoxBFE/KeyboardImpl.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxBFE/KeyboardImpl.cpp	(revision 11158)
+++ trunk/src/VBox/Frontends/VBoxBFE/KeyboardImpl.cpp	(revision 11307)
@@ -168,5 +168,5 @@
 {
     PPDMDRVINS pDrvIns = PDMIBASE_2_PDMDRV(pInterface);
-    PDRVMAINKEYBOARD pDrv = PDMINS2DATA(pDrvIns, PDRVMAINKEYBOARD);
+    PDRVMAINKEYBOARD pDrv = PDMINS_2_DATA(pDrvIns, PDRVMAINKEYBOARD);
     switch (enmInterface)
     {
@@ -189,5 +189,5 @@
 DECLCALLBACK(void) Keyboard::drvDestruct(PPDMDRVINS pDrvIns)
 {
-    PDRVMAINKEYBOARD pData = PDMINS2DATA(pDrvIns, PDRVMAINKEYBOARD);
+    PDRVMAINKEYBOARD pData = PDMINS_2_DATA(pDrvIns, PDRVMAINKEYBOARD);
     LogFlow(("Keyboard::drvDestruct: iInstance=%d\n", pDrvIns->iInstance));
     if (pData->pKeyboard)
@@ -218,5 +218,5 @@
 DECLCALLBACK(int) Keyboard::drvConstruct(PPDMDRVINS pDrvIns, PCFGMNODE pCfgHandle)
 {
-    PDRVMAINKEYBOARD pData = PDMINS2DATA(pDrvIns, PDRVMAINKEYBOARD);
+    PDRVMAINKEYBOARD pData = PDMINS_2_DATA(pDrvIns, PDRVMAINKEYBOARD);
     LogFlow(("Keyboard::drvConstruct: iInstance=%d\n", pDrvIns->iInstance));
 
Index: trunk/src/VBox/Frontends/VBoxBFE/MouseImpl.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxBFE/MouseImpl.cpp	(revision 11158)
+++ trunk/src/VBox/Frontends/VBoxBFE/MouseImpl.cpp	(revision 11307)
@@ -187,5 +187,5 @@
 {
     PPDMDRVINS pDrvIns = PDMIBASE_2_PDMDRV(pInterface);
-    PDRVMAINMOUSE pDrv = PDMINS2DATA(pDrvIns, PDRVMAINMOUSE);
+    PDRVMAINMOUSE pDrv = PDMINS_2_DATA(pDrvIns, PDRVMAINMOUSE);
     switch (enmInterface)
     {
@@ -208,5 +208,5 @@
 DECLCALLBACK(void) Mouse::drvDestruct(PPDMDRVINS pDrvIns)
 {
-    //PDRVMAINMOUSE pData = PDMINS2DATA(pDrvIns, PDRVMAINMOUSE);
+    //PDRVMAINMOUSE pData = PDMINS_2_DATA(pDrvIns, PDRVMAINMOUSE);
     LogFlow(("Mouse::drvDestruct: iInstance=%d\n", pDrvIns->iInstance));
 }
@@ -225,5 +225,5 @@
 DECLCALLBACK(int) Mouse::drvConstruct(PPDMDRVINS pDrvIns, PCFGMNODE pCfgHandle)
 {
-    PDRVMAINMOUSE pData = PDMINS2DATA(pDrvIns, PDRVMAINMOUSE);
+    PDRVMAINMOUSE pData = PDMINS_2_DATA(pDrvIns, PDRVMAINMOUSE);
     LogFlow(("drvMainMouse_Construct: iInstance=%d\n", pDrvIns->iInstance));
 
Index: trunk/src/VBox/Frontends/VBoxBFE/StatusImpl.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxBFE/StatusImpl.cpp	(revision 11158)
+++ trunk/src/VBox/Frontends/VBoxBFE/StatusImpl.cpp	(revision 11307)
@@ -94,5 +94,5 @@
 {
     PPDMDRVINS pDrvIns = PDMIBASE_2_PDMDRV(pInterface);
-    PDRVMAINSTATUS pDrv = PDMINS2DATA(pDrvIns, PDRVMAINSTATUS);
+    PDRVMAINSTATUS pDrv = PDMINS_2_DATA(pDrvIns, PDRVMAINSTATUS);
     switch (enmInterface)
     {
@@ -115,5 +115,5 @@
 DECLCALLBACK(void) VMStatus::drvDestruct(PPDMDRVINS pDrvIns)
 {
-    PDRVMAINSTATUS pData = PDMINS2DATA(pDrvIns, PDRVMAINSTATUS);
+    PDRVMAINSTATUS pData = PDMINS_2_DATA(pDrvIns, PDRVMAINSTATUS);
     LogFlow(("VMStatus::drvDestruct: iInstance=%d\n", pDrvIns->iInstance));
     if (pData->papLeds)
@@ -138,5 +138,5 @@
 DECLCALLBACK(int) VMStatus::drvConstruct(PPDMDRVINS pDrvIns, PCFGMNODE pCfgHandle)
 {
-    PDRVMAINSTATUS pData = PDMINS2DATA(pDrvIns, PDRVMAINSTATUS);
+    PDRVMAINSTATUS pData = PDMINS_2_DATA(pDrvIns, PDRVMAINSTATUS);
     LogFlow(("VMStatus::drvConstruct: iInstance=%d\n", pDrvIns->iInstance));
 
Index: trunk/src/VBox/Frontends/VBoxBFE/VMMDevInterface.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxBFE/VMMDevInterface.cpp	(revision 11158)
+++ trunk/src/VBox/Frontends/VBoxBFE/VMMDevInterface.cpp	(revision 11307)
@@ -268,5 +268,5 @@
 
     PDRVMAINVMMDEV pDrv = PDMIHGCMCONNECTOR_2_MAINVMMDEV(pInterface);
-    
+
     if (    !pServiceLocation
         || (   pServiceLocation->type != VMMDevHGCMLoc_LocalHost
@@ -353,5 +353,5 @@
 {
     PPDMDRVINS pDrvIns = PDMIBASE_2_PDMDRV(pInterface);
-    PDRVMAINVMMDEV pDrv = PDMINS2DATA(pDrvIns, PDRVMAINVMMDEV);
+    PDRVMAINVMMDEV pDrv = PDMINS_2_DATA(pDrvIns, PDRVMAINVMMDEV);
     switch (enmInterface)
     {
@@ -381,5 +381,5 @@
 DECLCALLBACK(void) VMMDev::drvDestruct(PPDMDRVINS pDrvIns)
 {
-    /*PDRVMAINVMMDEV pData = PDMINS2DATA(pDrvIns, PDRVMAINVMMDEV); - unused variables makes gcc bitch. */
+    /*PDRVMAINVMMDEV pData = PDMINS_2_DATA(pDrvIns, PDRVMAINVMMDEV); - unused variables makes gcc bitch. */
 }
 
@@ -397,5 +397,5 @@
 DECLCALLBACK(int) VMMDev::drvConstruct(PPDMDRVINS pDrvIns, PCFGMNODE pCfgHandle)
 {
-    PDRVMAINVMMDEV pData = PDMINS2DATA(pDrvIns, PDRVMAINVMMDEV);
+    PDRVMAINVMMDEV pData = PDMINS_2_DATA(pDrvIns, PDRVMAINVMMDEV);
     LogFlow(("Keyboard::drvConstruct: iInstance=%d\n", pDrvIns->iInstance));
 
@@ -488,5 +488,5 @@
     }
 #endif /* VBOX_HGCM */
-    
+
     return VINF_SUCCESS;
 }