Index: trunk/src/VBox/VMM/PGMInternal.h
===================================================================
--- trunk/src/VBox/VMM/PGMInternal.h	(revision 11303)
+++ trunk/src/VBox/VMM/PGMInternal.h	(revision 11309)
@@ -3770,5 +3770,5 @@
     }
     Log2(("PHYS2VIRT: Removing %VGp-%VGp %#RX32 %s\n",
-          pPhys2Virt->Core.Key, pPhys2Virt->Core.KeyLast, pPhys2Virt->offNextAlias, HCSTRING(pCur->pszDesc)));
+          pPhys2Virt->Core.Key, pPhys2Virt->Core.KeyLast, pPhys2Virt->offNextAlias, R3STRING(pCur->pszDesc)));
     pPhys2Virt->offNextAlias = 0;
     pPhys2Virt->Core.KeyLast = NIL_RTGCPHYS; /* require reinsert */
Index: trunk/src/VBox/VMM/VMMAll/PGMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PGMAll.cpp	(revision 11303)
+++ trunk/src/VBox/VMM/VMMAll/PGMAll.cpp	(revision 11309)
@@ -188,13 +188,13 @@
 #include "PGMAllShw.h"
 
-/* Guest - protected mode */ 
-#define PGM_GST_TYPE                PGM_TYPE_PROT 
-#define PGM_GST_NAME(name)          PGM_GST_NAME_PROT(name) 
-#define PGM_BTH_NAME(name)          PGM_BTH_NAME_AMD64_PROT(name) 
-#define BTH_PGMPOOLKIND_PT_FOR_PT   PGMPOOLKIND_PAE_PT_FOR_PHYS 
-#include "PGMAllBth.h" 
-#undef BTH_PGMPOOLKIND_PT_FOR_PT 
-#undef PGM_BTH_NAME 
-#undef PGM_GST_TYPE 
+/* Guest - protected mode */
+#define PGM_GST_TYPE                PGM_TYPE_PROT
+#define PGM_GST_NAME(name)          PGM_GST_NAME_PROT(name)
+#define PGM_BTH_NAME(name)          PGM_BTH_NAME_AMD64_PROT(name)
+#define BTH_PGMPOOLKIND_PT_FOR_PT   PGMPOOLKIND_PAE_PT_FOR_PHYS
+#include "PGMAllBth.h"
+#undef BTH_PGMPOOLKIND_PT_FOR_PT
+#undef PGM_BTH_NAME
+#undef PGM_GST_TYPE
 #undef PGM_GST_NAME
 
@@ -938,9 +938,9 @@
     }
     /* The PDPT was cached or created; hook it up now. */
-    pPml4e->u |=   pShwPage->Core.Key 
+    pPml4e->u |=   pShwPage->Core.Key
                 | (pGstPml4e->u & ~(X86_PML4E_PG_MASK | X86_PML4E_AVL_MASK | X86_PML4E_PCD | X86_PML4E_PWT));
 
     const unsigned iPdPt = (GCPtr >> X86_PDPT_SHIFT) & X86_PDPT_MASK_AMD64;
-    PX86PDPT  pPdpt = (PX86PDPT)PGMPOOL_PAGE_2_PTR(pVM, pShwPage);    
+    PX86PDPT  pPdpt = (PX86PDPT)PGMPOOL_PAGE_2_PTR(pVM, pShwPage);
     PX86PDPE  pPdpe = &pPdpt->a[iPdPt];
 
@@ -1393,5 +1393,5 @@
 
 /**
- * Performs and schedules necessary updates following a CR3 load or reload, 
+ * Performs and schedules necessary updates following a CR3 load or reload,
  * without actually flushing the TLB as with PGMFlushTLB.
  *
@@ -1712,5 +1712,5 @@
             if (rc != VERR_PAGE_TABLE_NOT_PRESENT)
             {
-                AssertMsgFailed(("Conflict at %VGv with %s\n", GCPtr, HCSTRING(pMapping->pszDesc)));
+                AssertMsgFailed(("Conflict at %VGv with %s\n", GCPtr, R3STRING(pMapping->pszDesc)));
                 cErrors++;
                 break;
Index: trunk/src/VBox/VMM/VMMAll/PGMAllHandler.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PGMAllHandler.cpp	(revision 11303)
+++ trunk/src/VBox/VMM/VMMAll/PGMAllHandler.cpp	(revision 11309)
@@ -86,5 +86,5 @@
 {
     Log(("PGMHandlerPhysicalRegisterEx: enmType=%d GCPhys=%VGp GCPhysLast=%VGp pfnHandlerR3=%VHv pvUserR3=%VHv pfnHandlerR0=%VHv pvUserR0=%VHv pfnHandlerGC=%VRv pvUserGC=%VRv pszDesc=%s\n",
-          enmType, GCPhys, GCPhysLast, pfnHandlerR3, pvUserR3, pfnHandlerR0, pvUserR0, pfnHandlerGC, pvUserGC, HCSTRING(pszDesc)));
+          enmType, GCPhys, GCPhysLast, pfnHandlerR3, pvUserR3, pfnHandlerR0, pvUserR0, pfnHandlerGC, pvUserGC, R3STRING(pszDesc)));
 
     /*
@@ -294,5 +294,5 @@
     {
         LogFlow(("PGMHandlerPhysicalDeregister: Removing Range %#VGp-%#VGp %s\n",
-                 pCur->Core.Key, pCur->Core.KeyLast, HCSTRING(pCur->pszDesc)));
+                 pCur->Core.Key, pCur->Core.KeyLast, R3STRING(pCur->pszDesc)));
 
         /*
@@ -1264,5 +1264,5 @@
     {
         AssertMsgFailed(("virt handler phys has incorrect key! %VGp %VGv %s\n",
-                         pVirt->aPhysToVirt[0].Core.Key, pVirt->GCPtr, HCSTRING(pVirt->pszDesc)));
+                         pVirt->aPhysToVirt[0].Core.Key, pVirt->GCPtr, R3STRING(pVirt->pszDesc)));
         pState->cErrors++;
     }
@@ -1272,5 +1272,5 @@
     {
         AssertMsgFailed(("virt handler phys has incorrect key! %VGp %VGv %s\n",
-                         pVirt->aPhysToVirt[pVirt->cPages - 1].Core.KeyLast, pVirt->GCPtrLast, HCSTRING(pVirt->pszDesc)));
+                         pVirt->aPhysToVirt[pVirt->cPages - 1].Core.KeyLast, pVirt->GCPtrLast, R3STRING(pVirt->pszDesc)));
         pState->cErrors++;
     }
@@ -1291,5 +1291,5 @@
             {
                 AssertMsgFailed(("virt handler phys out of sync. %VGp GCPhysNew=~0 iPage=%#x %VGv %s\n",
-                                 pVirt->aPhysToVirt[iPage].Core.Key, iPage, GCPtr, HCSTRING(pVirt->pszDesc)));
+                                 pVirt->aPhysToVirt[iPage].Core.Key, iPage, GCPtr, R3STRING(pVirt->pszDesc)));
                 pState->cErrors++;
             }
@@ -1301,5 +1301,5 @@
         {
             AssertMsgFailed(("virt handler phys out of sync. %VGp GCPhysGst=%VGp iPage=%#x %VGv %s\n",
-                             pVirt->aPhysToVirt[iPage].Core.Key, GCPhysGst, iPage, GCPtr, HCSTRING(pVirt->pszDesc)));
+                             pVirt->aPhysToVirt[iPage].Core.Key, GCPhysGst, iPage, GCPtr, R3STRING(pVirt->pszDesc)));
             pState->cErrors++;
             continue;
@@ -1310,5 +1310,5 @@
         {
             AssertMsgFailed(("virt handler getting ram flags. GCPhysGst=%VGp iPage=%#x %VGv %s\n",
-                             GCPhysGst, iPage, GCPtr, HCSTRING(pVirt->pszDesc)));
+                             GCPhysGst, iPage, GCPtr, R3STRING(pVirt->pszDesc)));
             pState->cErrors++;
             continue;
@@ -1318,5 +1318,5 @@
         {
             AssertMsgFailed(("virt handler state mismatch. HCPhys=%VHp GCPhysGst=%VGp iPage=%#x %VGv state=%d expected>=%d %s\n",
-                             pPage->HCPhys, GCPhysGst, iPage, GCPtr, PGM_PAGE_GET_HNDL_VIRT_STATE(pPage), uState, HCSTRING(pVirt->pszDesc)));
+                             pPage->HCPhys, GCPhysGst, iPage, GCPtr, PGM_PAGE_GET_HNDL_VIRT_STATE(pPage), uState, R3STRING(pVirt->pszDesc)));
             pState->cErrors++;
             continue;
Index: trunk/src/VBox/VMM/VMMAll/TMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/TMAll.cpp	(revision 11303)
+++ trunk/src/VBox/VMM/VMMAll/TMAll.cpp	(revision 11309)
@@ -389,5 +389,5 @@
         TMTIMERSTATE enmState = pTimer->enmState;
         Log2(("TMTimerDestroy: pTimer=%p:{.enmState=%s, .pszDesc='%s'} cRetries=%d\n",
-              pTimer, tmTimerState(enmState), HCSTRING(pTimer->pszDesc), cRetries));
+              pTimer, tmTimerState(enmState), R3STRING(pTimer->pszDesc), cRetries));
         switch (enmState)
         {
@@ -395,5 +395,5 @@
                 if (!VM_IS_EMT(pTimer->CTXALLSUFF(pVM)))
                 {
-                    AssertMsgFailed(("Attempted timer destruction from other thread while expire pending! (%s)\n", HCSTRING(pTimer->pszDesc)));
+                    AssertMsgFailed(("Attempted timer destruction from other thread while expire pending! (%s)\n", R3STRING(pTimer->pszDesc)));
                     return VERR_INVALID_PARAMETER;
                 }
@@ -426,5 +426,5 @@
             case TMTIMERSTATE_PENDING_DESTROY:
             case TMTIMERSTATE_PENDING_STOP_DESTROY:
-                AssertMsgFailed(("How many times do you think you can destroy the same timer... (%s)\n", HCSTRING(pTimer->pszDesc)));
+                AssertMsgFailed(("How many times do you think you can destroy the same timer... (%s)\n", R3STRING(pTimer->pszDesc)));
                 return VERR_INVALID_PARAMETER;
 
@@ -457,13 +457,13 @@
              */
             case TMTIMERSTATE_FREE:
-                AssertMsgFailed(("Invalid timer state %d (%s)\n", enmState, HCSTRING(pTimer->pszDesc)));
+                AssertMsgFailed(("Invalid timer state %d (%s)\n", enmState, R3STRING(pTimer->pszDesc)));
                 return VERR_TM_INVALID_STATE;
             default:
-                AssertMsgFailed(("Unknown timer state %d (%s)\n", enmState, HCSTRING(pTimer->pszDesc)));
+                AssertMsgFailed(("Unknown timer state %d (%s)\n", enmState, R3STRING(pTimer->pszDesc)));
                 return VERR_TM_UNKNOWN_STATE;
         }
     } while (cRetries-- > 0);
 
-    AssertMsgFailed(("Failed waiting for stable state. state=%d (%s)\n", pTimer->enmState, HCSTRING(pTimer->pszDesc)));
+    AssertMsgFailed(("Failed waiting for stable state. state=%d (%s)\n", pTimer->enmState, R3STRING(pTimer->pszDesc)));
     return VERR_INTERNAL_ERROR;
 }
@@ -490,5 +490,5 @@
         TMTIMERSTATE    enmState = pTimer->enmState;
         Log2(("TMTimerSet: pTimer=%p:{.enmState=%s, .pszDesc='%s'} cRetries=%d u64Expire=%llu\n",
-              pTimer, tmTimerState(enmState), HCSTRING(pTimer->pszDesc), cRetries, u64Expire));
+              pTimer, tmTimerState(enmState), R3STRING(pTimer->pszDesc), cRetries, u64Expire));
         switch (enmState)
         {
@@ -566,13 +566,13 @@
             case TMTIMERSTATE_PENDING_STOP_DESTROY:
             case TMTIMERSTATE_FREE:
-                AssertMsgFailed(("Invalid timer state %d (%s)\n", enmState, HCSTRING(pTimer->pszDesc)));
+                AssertMsgFailed(("Invalid timer state %d (%s)\n", enmState, R3STRING(pTimer->pszDesc)));
                 return VERR_TM_INVALID_STATE;
             default:
-                AssertMsgFailed(("Unknown timer state %d (%s)\n", enmState, HCSTRING(pTimer->pszDesc)));
+                AssertMsgFailed(("Unknown timer state %d (%s)\n", enmState, R3STRING(pTimer->pszDesc)));
                 return VERR_TM_UNKNOWN_STATE;
         }
     } while (cRetries-- > 0);
 
-    AssertMsgFailed(("Failed waiting for stable state. state=%d (%s)\n", pTimer->enmState, HCSTRING(pTimer->pszDesc)));
+    AssertMsgFailed(("Failed waiting for stable state. state=%d (%s)\n", pTimer->enmState, R3STRING(pTimer->pszDesc)));
     STAM_PROFILE_STOP(&pTimer->CTXALLSUFF(pVM)->tm.s.CTXALLSUFF(StatTimerSet), a);
     return VERR_INTERNAL_ERROR;
@@ -696,5 +696,5 @@
         TMTIMERSTATE    enmState = pTimer->enmState;
         Log2(("TMTimerStop: pTimer=%p:{.enmState=%s, .pszDesc='%s'} cRetries=%d\n",
-              pTimer, tmTimerState(enmState), HCSTRING(pTimer->pszDesc), cRetries));
+              pTimer, tmTimerState(enmState), R3STRING(pTimer->pszDesc), cRetries));
         switch (enmState)
         {
@@ -753,13 +753,13 @@
             case TMTIMERSTATE_PENDING_STOP_DESTROY:
             case TMTIMERSTATE_FREE:
-                AssertMsgFailed(("Invalid timer state %d (%s)\n", enmState, HCSTRING(pTimer->pszDesc)));
+                AssertMsgFailed(("Invalid timer state %d (%s)\n", enmState, R3STRING(pTimer->pszDesc)));
                 return VERR_TM_INVALID_STATE;
             default:
-                AssertMsgFailed(("Unknown timer state %d (%s)\n", enmState, HCSTRING(pTimer->pszDesc)));
+                AssertMsgFailed(("Unknown timer state %d (%s)\n", enmState, R3STRING(pTimer->pszDesc)));
                 return VERR_TM_UNKNOWN_STATE;
         }
     } while (cRetries-- > 0);
 
-    AssertMsgFailed(("Failed waiting for stable state. state=%d (%s)\n", pTimer->enmState, HCSTRING(pTimer->pszDesc)));
+    AssertMsgFailed(("Failed waiting for stable state. state=%d (%s)\n", pTimer->enmState, R3STRING(pTimer->pszDesc)));
     STAM_PROFILE_STOP(&pTimer->CTXALLSUFF(pVM)->tm.s.CTXALLSUFF(StatTimerStop), a);
     return VERR_INTERNAL_ERROR;
@@ -798,5 +798,5 @@
     }
     //Log2(("TMTimerGet: returns %llu (pTimer=%p:{.enmState=%s, .pszDesc='%s'})\n",
-    //      u64, pTimer, tmTimerState(pTimer->enmState), HCSTRING(pTimer->pszDesc)));
+    //      u64, pTimer, tmTimerState(pTimer->enmState), R3STRING(pTimer->pszDesc)));
     return u64;
 }
@@ -1081,5 +1081,5 @@
             case TMTIMERSTATE_PENDING_STOP_SCHEDULE:
                 Log2(("TMTimerGetExpire: returns ~0 (pTimer=%p:{.enmState=%s, .pszDesc='%s'})\n",
-                      pTimer, tmTimerState(pTimer->enmState), HCSTRING(pTimer->pszDesc)));
+                      pTimer, tmTimerState(pTimer->enmState), R3STRING(pTimer->pszDesc)));
                 return ~(uint64_t)0;
 
@@ -1088,5 +1088,5 @@
             case TMTIMERSTATE_PENDING_SCHEDULE:
                 Log2(("TMTimerGetExpire: returns %llu (pTimer=%p:{.enmState=%s, .pszDesc='%s'})\n",
-                      pTimer->u64Expire, pTimer, tmTimerState(pTimer->enmState), HCSTRING(pTimer->pszDesc)));
+                      pTimer->u64Expire, pTimer, tmTimerState(pTimer->enmState), R3STRING(pTimer->pszDesc)));
                 return pTimer->u64Expire;
 
@@ -1105,17 +1105,17 @@
             case TMTIMERSTATE_PENDING_STOP_DESTROY:
             case TMTIMERSTATE_FREE:
-                AssertMsgFailed(("Invalid timer state %d (%s)\n", enmState, HCSTRING(pTimer->pszDesc)));
+                AssertMsgFailed(("Invalid timer state %d (%s)\n", enmState, R3STRING(pTimer->pszDesc)));
                 Log2(("TMTimerGetExpire: returns ~0 (pTimer=%p:{.enmState=%s, .pszDesc='%s'})\n",
-                      pTimer, tmTimerState(pTimer->enmState), HCSTRING(pTimer->pszDesc)));
+                      pTimer, tmTimerState(pTimer->enmState), R3STRING(pTimer->pszDesc)));
                 return ~(uint64_t)0;
             default:
-                AssertMsgFailed(("Unknown timer state %d (%s)\n", enmState, HCSTRING(pTimer->pszDesc)));
+                AssertMsgFailed(("Unknown timer state %d (%s)\n", enmState, R3STRING(pTimer->pszDesc)));
                 return ~(uint64_t)0;
         }
     } while (cRetries-- > 0);
 
-    AssertMsgFailed(("Failed waiting for stable state. state=%d (%s)\n", pTimer->enmState, HCSTRING(pTimer->pszDesc)));
+    AssertMsgFailed(("Failed waiting for stable state. state=%d (%s)\n", pTimer->enmState, R3STRING(pTimer->pszDesc)));
     Log2(("TMTimerGetExpire: returns ~0 (pTimer=%p:{.enmState=%s, .pszDesc='%s'})\n",
-          pTimer, tmTimerState(pTimer->enmState), HCSTRING(pTimer->pszDesc)));
+          pTimer, tmTimerState(pTimer->enmState), R3STRING(pTimer->pszDesc)));
     return ~(uint64_t)0;
 }
@@ -1139,5 +1139,5 @@
         case TMTIMERSTATE_PENDING_STOP_SCHEDULE:
             Log2(("TMTimerIsActive: returns false (pTimer=%p:{.enmState=%s, .pszDesc='%s'})\n",
-                  pTimer, tmTimerState(pTimer->enmState), HCSTRING(pTimer->pszDesc)));
+                  pTimer, tmTimerState(pTimer->enmState), R3STRING(pTimer->pszDesc)));
             return false;
 
@@ -1148,5 +1148,5 @@
         case TMTIMERSTATE_PENDING_RESCHEDULE_SET_EXPIRE:
             Log2(("TMTimerIsActive: returns true (pTimer=%p:{.enmState=%s, .pszDesc='%s'})\n",
-                  pTimer, tmTimerState(pTimer->enmState), HCSTRING(pTimer->pszDesc)));
+                  pTimer, tmTimerState(pTimer->enmState), R3STRING(pTimer->pszDesc)));
             return true;
 
@@ -1157,10 +1157,10 @@
         case TMTIMERSTATE_PENDING_STOP_DESTROY:
         case TMTIMERSTATE_FREE:
-            AssertMsgFailed(("Invalid timer state %s (%s)\n", tmTimerState(enmState), HCSTRING(pTimer->pszDesc)));
+            AssertMsgFailed(("Invalid timer state %s (%s)\n", tmTimerState(enmState), R3STRING(pTimer->pszDesc)));
             Log2(("TMTimerIsActive: returns false (pTimer=%p:{.enmState=%s, .pszDesc='%s'})\n",
-                  pTimer, tmTimerState(pTimer->enmState), HCSTRING(pTimer->pszDesc)));
+                  pTimer, tmTimerState(pTimer->enmState), R3STRING(pTimer->pszDesc)));
             return false;
         default:
-            AssertMsgFailed(("Unknown timer state %d (%s)\n", enmState, HCSTRING(pTimer->pszDesc)));
+            AssertMsgFailed(("Unknown timer state %d (%s)\n", enmState, R3STRING(pTimer->pszDesc)));
             return false;
     }
@@ -1424,5 +1424,5 @@
          */
         Log2(("tmTimerQueueSchedule: pTimer=%p:{.enmState=%s, .enmClock=%d, .enmType=%d, .pszDesc=%s}\n",
-              pTimer, tmTimerState(pTimer->enmState), pTimer->enmClock, pTimer->enmType, HCSTRING(pTimer->pszDesc)));
+              pTimer, tmTimerState(pTimer->enmState), pTimer->enmClock, pTimer->enmType, R3STRING(pTimer->pszDesc)));
         tmTimerQueueScheduleOne(pQueue, pTimer);
         Log2(("tmTimerQueueSchedule: new %s\n", tmTimerState(pTimer->enmState)));